Subject: Re: bug#66503: 29.1; Problem rendering Arabic diacriticals

From: Alan Third <[email-masked]>
Date: Sat, 14 Oct 2023 09:56:50 +0100

On Sat, Oct 14, 2023 at 09:57:48AM +0300, Eli Zaretskii wrote:
> > From: John Wiegley <[email-masked]>
> > Cc: [email-masked]
> > Date: Fri, 13 Oct 2023 22:19:52 -0700
> > 
> > I have found a workaround: By typing “shadda followed by fatha” instead of
> > “fatha followed by shadda”, my Emacs renders it correctly. Here are the two
> > different lines:
> > 
> > لَنَهْدِيَنَّهُمْ
> > لَنَهْدِيَنَّهُمْ
> > 
> > In Mellel these are both rendered the same, but (my) Emacs treats them quite
> > differently.
> 
> Both lines render identically here.  I think the conclusion is that
> the macOS text-shaping engine doesn't sort the combining characters
> before rendering them, which is what shaping engines are expected to
> do.  However, I don't consider myself an expert on this, so maybe
> raise this issue on some forum where the development of the macOS
> shaper is discussed?

FWIW, on my ancient version of macOS I see these looking the same too,
and they seem to match John's original correct screenshot. My own
screenshot attached.

It could be a difference between the NS port and the Mac port, or
perhaps its a regression in macOS.
-- 
Alan Third